diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
index 857c8b278..3f421b05d 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
@@ -255,7 +255,7 @@ public final class ItemStack {
 
     public void damageItem(int damage, @Nullable Entity entity) {
         if (entity instanceof Player) {
-            if (!((Player)entity).getGamemode().toolDurability()) return;
+            if (!((Player)entity).getGamemode().hasToolDurability()) return;
         }
         if(!isItemStackDamageable())
         {
@@ -313,7 +313,7 @@ public final class ItemStack {
         if(this.stackSize <= 0) {
             return false;
         }
-        if (entityplayer == null || entityplayer.getGamemode().consumeBlocks()) {
+        if (entityplayer == null || entityplayer.getGamemode().hasBlockConsumption()) {
             this.stackSize--;
         }
         return true;
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java b/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
index 09285a34e..8979d9b70 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemWandSpawner.java
@@ -2,12 +2,12 @@ package net.minecraft.core.item;
 
 import net.minecraft.core.block.entity.TileEntityActivator;
 import net.minecraft.core.entity.Mob;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.EntityDispatcher;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
@@ -22,7 +22,7 @@ public class ItemWandSpawner extends Item implements IDispensable
     }
     @Override
     public @Nullable ItemStack onUse(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player) {
-        if (player.gamemode != Gamemode.creative){
+        if (player.gamemode != Gamemodes.CREATIVE){
             player.sendTranslatedChatMessage("wand.wrongmode");
             return selfStack;
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
index 3578ffb7e..3f7f54fa6 100644
--- a/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
+++ b/game/core/src/main/java/net/minecraft/core/item/block/ItemBlock.java
@@ -59,7 +59,7 @@ public class ItemBlock<T extends BlockLogic> extends Item {
                 }
                 world.playBlockSoundEffect(player, blockPos.x() + 0.5F, blockPos.y() + 0.5F, blockPos.z() + 0.5F, this.block, EnumBlockSoundEffectType.PLACE);
                 return true;
-            } else if (player == null || player.getGamemode().consumeBlocks()) {
+            } else if (player == null || player.getGamemode().hasBlockConsumption()) {
                 selfStack.stackSize += 1;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/item/tag/ItemTags.java b/game/core/src/main/java/net/minecraft/core/item/tag/ItemTags.java
index bdbc8063a..e4edf7f3d 100644
--- a/game/core/src/main/java/net/minecraft/core/item/tag/ItemTags.java
+++ b/game/core/src/main/java/net/minecraft/core/item/tag/ItemTags.java
@@ -3,6 +3,7 @@ package net.minecraft.core.item.tag;
 import com.mojang.logging.LogUtils;
 import net.minecraft.core.data.tag.Tag;
 import net.minecraft.core.item.Item;
+import org.jetbrains.annotations.NotNull;
 import org.slf4j.Logger;
 
 import java.lang.reflect.Field;
@@ -15,29 +16,29 @@ public abstract class ItemTags
     /**
      * Items with this tag will not destroy blocks in creative mode
      */
-    public static Tag<Item> PREVENT_CREATIVE_MINING = Tag.of("prevent_creative_mining");
+    public static final @NotNull Tag<Item> PREVENT_CREATIVE_MINING = Tag.of("prevent_creative_mining");
     /**
      * Items with this tag will break blocks with silk touch
      */
-    public static Tag<Item> IS_SILK_TOUCH = Tag.of("is_silk_touch");
+    public static final @NotNull Tag<Item> IS_SILK_TOUCH = Tag.of("is_silk_touch");
     /**
      * Items with this tag will not be shown in the creative inventory.
      */
-    public static Tag<Item> NOT_IN_CREATIVE_MENU = Tag.of("not_in_creative_menu");
+    public static final @NotNull Tag<Item> NOT_IN_CREATIVE_MENU = Tag.of("not_in_creative_menu");
     /**
      * Blocks like doors and levers should not be interacted with when mining them with an item with this tag
      */
-    public static Tag<Item> PREVENT_LEFT_CLICK_INTERACTIONS = Tag.of("prevent_left_click_interactions");
+    public static final @NotNull Tag<Item> PREVENT_LEFT_CLICK_INTERACTIONS = Tag.of("prevent_left_click_interactions");
     /**
      * Chickens will follow the player if they are holding this item.
      */
-    public static Tag<Item> CHICKENS_FAVOURITE_ITEM = Tag.of("chickens_favourite_item");
+    public static final @NotNull Tag<Item> CHICKENS_FAVOURITE_ITEM = Tag.of("chickens_favourite_item");
     /**
      * Cows will follow the player if they are holding this item.
      */
-    public static Tag<Item> COWS_FAVOURITE_ITEM = Tag.of("cows_favourite_item");
+    public static final @NotNull Tag<Item> COWS_FAVOURITE_ITEM = Tag.of("cows_favourite_item");
 
-    public static List<Tag<Item>> TAG_LIST;
+    public static final @NotNull List<@NotNull Tag<@NotNull Item>> TAG_LIST;
 
     static
     {
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeGameMode.java b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeGameMode.java
index 8bca8bfc1..431217d1d 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeGameMode.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/arguments/ArgumentTypeGameMode.java
@@ -6,9 +6,11 @@ import com.mojang.brigadier.context.CommandContext;
 import com.mojang.brigadier.exceptions.CommandSyntaxException;
 import com.mojang.brigadier.suggestion.Suggestions;
 import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 
 import java.util.Arrays;
 import java.util.Collection;
@@ -16,7 +18,7 @@ import java.util.Optional;
 import java.util.concurrent.CompletableFuture;
 
 public class ArgumentTypeGameMode implements ArgumentType<Gamemode> {
-    private static final Collection<String> EXAMPLES = Arrays.asList(Gamemode.creative.getLanguageKey(), Gamemode.survival.getLanguageKey());
+    private static final Collection<String> EXAMPLES = Arrays.asList(Gamemodes.CREATIVE.getId(), Gamemodes.SURVIVAL.getId());
 
     public static ArgumentType<Gamemode> gameMode() {
         return new ArgumentTypeGameMode();
@@ -26,8 +28,8 @@ public class ArgumentTypeGameMode implements ArgumentType<Gamemode> {
     public Gamemode parse(StringReader reader) throws CommandSyntaxException {
         final String string = reader.readString();
 
-        for (Gamemode gamemode : Gamemode.gamemodesList) {
-            if (CommandHelper.matchesKeyString(gamemode.getLanguageKey(), string) || string.equals(String.valueOf(gamemode.getId()))) {
+        for (Gamemode gamemode : Registries.GAMEMODES) {
+            if (CommandHelper.matchesKeyString(gamemode.getId(), string)) {
                 return gamemode;
             }
         }
@@ -37,8 +39,8 @@ public class ArgumentTypeGameMode implements ArgumentType<Gamemode> {
     @Override
     public <S> CompletableFuture<Suggestions> listSuggestions(CommandContext<S> context, SuggestionsBuilder builder) {
         String remaining = builder.getRemainingLowerCase();
-        for (Gamemode gamemode : Gamemode.gamemodesList) {
-            Optional<String> optional = CommandHelper.getStringToSuggest(gamemode.getLanguageKey(), remaining);
+        for (Gamemode gamemode : Registries.GAMEMODES) {
+            Optional<String> optional = CommandHelper.getStringToSuggest(gamemode.getId(), remaining);
             optional.ifPresent(builder::suggest);
         }
         return builder.buildFuture();
diff --git a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorOptions.java b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorOptions.java
index 0f11eb454..b9e384c67 100644
--- a/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorOptions.java
+++ b/game/core/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorOptions.java
@@ -7,6 +7,7 @@ import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
 import com.mojang.brigadier.suggestion.SuggestionsBuilder;
 import com.mojang.nbt.tags.CompoundTag;
 import com.mojang.nbt.tags.Tag;
+import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.lang.text.ChainText;
 import net.minecraft.core.lang.text.Text;
 import net.minecraft.core.entity.Entity;
@@ -18,6 +19,7 @@ import net.minecraft.core.lang.I18n;
 import net.minecraft.core.net.command.util.CommandHelper;
 import net.minecraft.core.net.command.util.NbtHelper;
 import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.gamemode.Gamemodes;
 import net.minecraft.core.util.collection.NamespaceID;
 import net.minecraft.core.util.helper.LoggedPrintStream;
 
@@ -208,9 +210,9 @@ public class EntitySelectorOptions {
                         bl2 = false;
                     }
                 }
-                for (Gamemode gameMode : Gamemode.gamemodesList) {
-                    if (!CommandHelper.getStringToSuggest(gameMode.getLanguageKey(), string).isPresent()) continue;
-                    String stringToSuggest = CommandHelper.getStringToSuggest(gameMode.getLanguageKey(), string).get();
+                for (Gamemode gameMode : Registries.GAMEMODES) {
+                    if (!CommandHelper.getStringToSuggest(gameMode.getId(), string).isPresent()) continue;
+                    String stringToSuggest = CommandHelper.getStringToSuggest(gameMode.getId(), string).get();
                     if (bl2) {
                         builder.suggest("!" + stringToSuggest);
                     }
@@ -224,8 +226,8 @@ public class EntitySelectorOptions {
             String value = parser.getReader().readUnquotedString();
 
             Gamemode gamemode = null;
-            for (Gamemode iteratedGameMode : Gamemode.gamemodesList) {
-                if (CommandHelper.matchesKeyString(iteratedGameMode.getLanguageKey(), value)) {
+            for (Gamemode iteratedGameMode : Registries.GAMEMODES) {
+                if (CommandHelper.matchesKeyString(iteratedGameMode.getId(), value)) {
                     gamemode = iteratedGameMode;
                 }
             }
@@ -237,7 +239,7 @@ public class EntitySelectorOptions {
             parser.setIncludesEntities(false);
             parser.addPredicate((entity) -> {
                 if (!(entity instanceof Player)) return false;
-                return CommandHelper.matchesKeyString(((Player) entity).gamemode.getLanguageKey(), value) != invert;
+                return CommandHelper.matchesKeyString(((Player) entity).gamemode.getId(), value) != invert;
             });
 
             if (invert) {
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
index 6548d1f21..c99415d3f 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/Packet.java
@@ -38,6 +38,7 @@ public abstract class Packet
 
     public static final int MAX_USERNAME_SIZE = 16;
     public static final int MAX_NICKNAME_SIZE = 256;
+    public static final int MAX_REGISTRY_KEY_SIZE = 256;
     public static final int MAX_AES_KEY_SIZE = 392;
     public static final int MAX_MESSAGE_SIZE = 1024;
 
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddPlayer.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddPlayer.java
index 65a2c6991..5cd09ac5e 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddPlayer.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketAddPlayer.java
@@ -25,7 +25,7 @@ public class PacketAddPlayer extends Packet
     public String nickname;
     public byte chatColor;
     public short playerConfig;
-    public int gamemode;
+    public String gamemode;
 
 
     public PacketAddPlayer() {
@@ -73,7 +73,7 @@ public class PacketAddPlayer extends Packet
         this.nickname = readStringUTF16BE(dis, MAX_NICKNAME_SIZE);
         this.chatColor = dis.readByte();
         this.playerConfig = dis.readShort();
-        this.gamemode = Byte.toUnsignedInt(dis.readByte());
+        this.gamemode = readStringUTF16BE(dis, MAX_REGISTRY_KEY_SIZE);
 
         if (dis.readByte() == 1) {
             this.heldObjectTag = readCompressedCompoundTag(dis);
@@ -98,7 +98,7 @@ public class PacketAddPlayer extends Packet
         writeStringUTF16BE(this.nickname, dos);
         dos.writeByte(this.chatColor);
         dos.writeShort(this.playerConfig);
-        dos.writeByte(this.gamemode & 0xFF);
+        writeStringUTF16BE(this.gamemode, dos);
 
         if (this.heldObjectTag != null) {
             dos.writeByte(1);
diff --git a/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerGamemode.java b/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerGamemode.java
index 0c1300a96..8f14fefa1 100644
--- a/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerGamemode.java
+++ b/game/core/src/main/java/net/minecraft/core/net/packet/PacketPlayerGamemode.java
@@ -11,7 +11,7 @@ public class PacketPlayerGamemode extends Packet
     {
     }
     
-    public PacketPlayerGamemode(int entityId, int gamemodeId)
+    public PacketPlayerGamemode(int entityId, String gamemodeId)
     {
         this.entityId = entityId;
         this.gamemodeId = gamemodeId;
@@ -22,7 +22,7 @@ public class PacketPlayerGamemode extends Packet
         throws IOException
     {
         entityId = dis.readInt();
-        gamemodeId = dis.readByte();
+        gamemodeId = readStringUTF16BE(dis, MAX_REGISTRY_KEY_SIZE);
     }
 
     @Override
@@ -30,7 +30,7 @@ public class PacketPlayerGamemode extends Packet
         throws IOException
     {
         dos.writeInt(entityId);
-        dos.writeByte(gamemodeId);
+        writeStringUTF16BE(gamemodeId, dos);
     }
 
     @Override
@@ -45,6 +45,6 @@ public class PacketPlayerGamemode extends Packet
         return 5;
     }
 
-    public int gamemodeId;
+    public String gamemodeId;
     public int entityId;
 }
diff --git a/game/core/src/main/java/net/minecraft/core/player/gamemode/Gamemode.java b/game/core/src/main/java/net/minecraft/core/player/gamemode/Gamemode.java
index a3f41a29c..681a78a03 100644
--- a/game/core/src/main/java/net/minecraft/core/player/gamemode/Gamemode.java
+++ b/game/core/src/main/java/net/minecraft/core/player/gamemode/Gamemode.java
@@ -1,203 +1,189 @@
 package net.minecraft.core.player.gamemode;
 
+import net.minecraft.core.data.registry.Registries;
 import net.minecraft.core.player.inventory.menu.MenuInventory;
 import net.minecraft.core.player.inventory.container.ContainerInventory;
-
-import java.util.ArrayList;
-import java.util.List;
-
-public abstract class Gamemode
-{
-	private final int id;
-	private final String languageKey;
-
-	private boolean isPlayerInvulnerable = false;
-	private boolean canPlayerFly = false;
-	private boolean consumeBlocks = false;
-	private boolean doBlockBreakingAnim = false;
-	private boolean toolDurability = false;
-	private boolean dropBlockOnBreak = false;
-	private boolean areMobsHostile = false;
-	private boolean isImmuneToFire = false;
-	private boolean instantPortalTravel = false;
-	private boolean requireToolToBreak = false;
-	private boolean canInteract = true;
-	private boolean hideFromWorldCreation = false;
-	private boolean isPermaDeath = false;
-	private float blockReachDistance = 4.5f;
-	private float entityReachDistance = 3.0f;
-	
-	public Gamemode(int id, String languageKey)
-	{
-		this.id = id;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.Objects;
+import java.util.function.Function;
+
+/**
+ * A gamemode is essentially a collection of persistent status effects on a player. It defines a lot of core behaviours
+ * in the game, such as whether the player is invulnerable, whether blocks are dropped, and whether they can fly.
+ */
+public final class Gamemode {
+    private final @NotNull String languageKey;
+    private final @NotNull Function<@NotNull ContainerInventory, @NotNull MenuInventory> inventoryMenuSupplier;
+    private final boolean invulnerablePlayer;
+    private final boolean playerFlight;
+    private final boolean blockConsumption;
+    private final boolean blockBreakingAnimation;
+    private final boolean toolDurability;
+    private final boolean itemDrops;
+    private final boolean hostileMobs;
+    private final boolean fireImmunity;
+    private final boolean instantPortalTravel;
+    private final boolean properToolNeededToMine;
+    private final boolean canInteract;
+    private final boolean permaDeath;
+    private final float blockReachDistance;
+    private final float entityReachDistance;
+
+	/* package-private */ Gamemode(
+		final @NotNull String languageKey,
+		final @NotNull Function<@NotNull ContainerInventory, @NotNull MenuInventory> inventoryMenuSupplier,
+		final boolean invulnerablePlayer,
+		final boolean playerFlight,
+		final boolean blockConsumption,
+		final boolean blockBreakingAnimation,
+		final boolean toolDurability,
+		final boolean itemDrops,
+		final boolean hostileMobs,
+		final boolean fireImmunity,
+		final boolean instantPortalTravel,
+		final boolean properToolNeededToMine,
+		final boolean canInteract,
+		final boolean permaDeath,
+		final float blockReachDistance,
+		final float entityReachDistance
+	) {
 		this.languageKey = languageKey;
-		gamemodesList[id] = this;
-	}
-
-	public int getId() {
-		return id;
-	}
-
-	public String getLanguageKey() {
-		return languageKey;
-	}
-
-	public Gamemode setIsPlayerInvulnerable()
-	{
-		isPlayerInvulnerable = true;
-		return this;
-	}
-
-	public boolean isPlayerInvulnerable() {
-		return isPlayerInvulnerable;
-	}
-
-	public Gamemode setCanPlayerFly()
-	{
-		canPlayerFly = true;
-		return this;
-	}
-
-	public boolean canPlayerFly() {
-		return canPlayerFly;
-	}
-
-	public Gamemode setConsumeBlocks()
-	{
-		consumeBlocks = true;
-		return this;
-	}
-
-	public boolean consumeBlocks() {
-		return consumeBlocks;
-	}
-
-	public Gamemode setDoBlockBreakingAnim()
-	{
-		doBlockBreakingAnim = true;
-		return this;
-	}
-
-	public boolean doBlockBreakingAnim() {
-		return doBlockBreakingAnim;
-	}
-
-	public Gamemode setToolDurability()
-	{
-		toolDurability = true;
-		return this;
-	}
-
-	public boolean toolDurability() {
-		return toolDurability;
-	}
-
-	public Gamemode setDropBlockOnBreak()
-	{
-		dropBlockOnBreak = true;
-		return this;
-	}
-
-	public boolean dropBlockOnBreak() {
-		return dropBlockOnBreak;
-	}
-
-	public Gamemode setAreMobsHostile()
-	{
-		areMobsHostile = true;
-		return this;
-	}
-
-	public boolean areMobsHostile() {
-		return areMobsHostile;
-	}
-
-	public Gamemode setIsImmuneToFire()
-	{
-		isImmuneToFire = true;
-		return this;
-	}
-
-	public boolean isImmuneToFire() {
-		return isImmuneToFire;
-	}
-
-	public Gamemode setInstantPortalTravel()
-	{
-		this.instantPortalTravel = true;
-		return this;
-	}
-
-	public boolean instantPortalTravel() {
-		return instantPortalTravel;
-	}
-
-	public Gamemode setBlockReachDistance(float blockReachDistance)
-	{
+		this.inventoryMenuSupplier = inventoryMenuSupplier;
+		this.invulnerablePlayer = invulnerablePlayer;
+		this.playerFlight = playerFlight;
+		this.blockConsumption = blockConsumption;
+		this.blockBreakingAnimation = blockBreakingAnimation;
+		this.toolDurability = toolDurability;
+		this.itemDrops = itemDrops;
+		this.hostileMobs = hostileMobs;
+		this.fireImmunity = fireImmunity;
+		this.instantPortalTravel = instantPortalTravel;
+		this.properToolNeededToMine = properToolNeededToMine;
+		this.canInteract = canInteract;
+		this.permaDeath = permaDeath;
 		this.blockReachDistance = blockReachDistance;
-		return this;
-	}
-
-	public float getBlockReachDistance() {
-		return blockReachDistance;
-	}
-	public Gamemode setEntityReachDistance(float entityReachDistance)
-	{
 		this.entityReachDistance = entityReachDistance;
-		return this;
-	}
-	public float getEntityReachDistance() {
-		return entityReachDistance;
-	}
-
-	public boolean doesRequireToolToBreak(){
-		return requireToolToBreak;
-	}
-	public Gamemode setRequireToolToBreak()
-	{
-		this.requireToolToBreak = true;
-		return this;
-	}
-	public boolean canInteract(){
-		return canInteract;
-	}
-	public Gamemode setCantInteract()
-	{
-		this.canInteract = false;
-		return this;
-	}
-
-	public boolean isHiddenFromWorldCreation(){
-		return hideFromWorldCreation;
-	}
-	public Gamemode setHideFromWorldCreation()
-	{
-		this.hideFromWorldCreation = true;
-		return this;
-	}
-	public boolean isPermaDeath(){
-		return isPermaDeath;
-	}
-	public Gamemode setPermaDeath()
-	{
-		this.isPermaDeath = true;
-		return this;
-	}
-
-	public abstract MenuInventory getContainer(ContainerInventory inventory, boolean isNotClientSide);
-
-	public static final Gamemode[] gamemodesList = new Gamemode[5];
-	public static List<Gamemode> getPublicGamemodes(){
-		List<Gamemode> gamemodes = new ArrayList<>();
-		for (Gamemode gamemode : gamemodesList){
-			if (gamemode.isHiddenFromWorldCreation()) continue;
-			gamemodes.add(gamemode);
-		}
-		return gamemodes;
-	}
-	public static final Gamemode survival = new GamemodeSurvival(0, "gamemode.survival").setConsumeBlocks().setDoBlockBreakingAnim().setToolDurability().setDropBlockOnBreak().setAreMobsHostile();
-	public static final Gamemode creative = new GamemodeCreative(1, "gamemode.creative").setIsPlayerInvulnerable().setCanPlayerFly().setIsImmuneToFire().setInstantPortalTravel().setBlockReachDistance(6.0f).setEntityReachDistance(4.5f);
-	public static final Gamemode hardcore = new GamemodeSurvival(2, "gamemode.hardcore").setConsumeBlocks().setDoBlockBreakingAnim().setToolDurability().setDropBlockOnBreak().setAreMobsHostile().setPermaDeath();
-	public static final Gamemode adventure = new GamemodeSurvival(3, "gamemode.adventure").setConsumeBlocks().setDoBlockBreakingAnim().setToolDurability().setDropBlockOnBreak().setAreMobsHostile().setRequireToolToBreak();
-	public static final Gamemode spectator = new GamemodeSurvival(4, "gamemode.spectator").setIsPlayerInvulnerable().setCanPlayerFly().setIsImmuneToFire().setInstantPortalTravel().setBlockReachDistance(5000).setEntityReachDistance(5000).setCantInteract().setHideFromWorldCreation();
+    }
+
+    /**
+     * Fetches the namespace ID for this gamemode.
+     */
+    public @NotNull String getId() {
+        return Objects.requireNonNull(Registries.GAMEMODES.getKey(this));
+    }
+
+    /**
+     * Fetches the language key for this gamemode.
+     */
+    public @NotNull String getLanguageKey() {
+        return this.languageKey;
+    }
+
+    /**
+     * Provides the correct {@link net.minecraft.core.player.inventory.menu.MenuInventory MenuInventory} wrapper for
+     * the provided {@link net.minecraft.core.player.inventory.container.ContainerInventory ContainerInventory}.
+     */
+	public @NotNull MenuInventory getInventoryMenu(final @NotNull ContainerInventory inventory) {
+		return this.inventoryMenuSupplier.apply(inventory);
+	}
+
+    /**
+     * If true, the player is immune to damage.
+     */
+    public boolean hasInvulnerablePlayer() {
+        return this.invulnerablePlayer;
+    }
+
+    /**
+     * If true, the player can fly.
+     */
+    public boolean hasPlayerFlight() {
+        return this.playerFlight;
+    }
+
+    /**
+     * If true, blocks in the inventory are consumed when placed.
+     */
+    public boolean hasBlockConsumption() {
+        return this.blockConsumption;
+    }
+
+    /**
+     * If true, blocks take time to break, and a breaking animation is displayed on the client.
+     */
+    public boolean hasBlockBreakingAnimation() {
+        return this.blockBreakingAnimation;
+    }
+
+    /**
+     * If true, tools lose durability when used, and will break when that durability runs out.
+     */
+    public boolean hasToolDurability() {
+        return this.toolDurability;
+    }
+
+    /**
+     * If true, items will drop when blocks are mined by the player.
+     */
+    public boolean hasItemDrops() {
+        return this.itemDrops;
+    }
+
+    /**
+     * If true, mobs will be hostile to the player.
+     */
+    public boolean hasHostileMobs() {
+        return this.hostileMobs;
+    }
+
+    /**
+     * If true, the player cannot be hurt by fire.
+     */
+    public boolean hasFireImmunity() {
+        return this.fireImmunity;
+    }
+
+    /**
+     * If true, the player will travel through dimensional portals instantly, rather than playing an animation first.
+     */
+    public boolean hasInstantPortalTravel() {
+        return this.instantPortalTravel;
+    }
+
+    /**
+     * Fetches the distance away from the player that blocks can be hit and interacted with.
+     */
+    public float getBlockReachDistance() {
+        return this.blockReachDistance;
+    }
+
+    /**
+     * Fetches the distance away from the player that entities can be hit and interacted with.
+     */
+    public float getEntityReachDistance() {
+        return this.entityReachDistance;
+    }
+
+    /**
+     * If true, blocks will only be mine-able using the correct tool, e.g. shovel on dirt, and will never break
+     * otherwise.
+     */
+    public boolean isProperToolNeededToMine() {
+        return this.properToolNeededToMine;
+    }
+
+    /**
+     * If true, the player can interact with mobs and entities.
+     */
+    public boolean canInteract() {
+        return this.canInteract;
+    }
+
+    /**
+     * If true, the player cannot respawn on death and will be forced to delete their world.
+     */
+    public boolean hasPermaDeath() {
+        return this.permaDeath;
+    }
 }
